<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Find Pair Sum Program</title>
  </head>
  <body>
    <h1>JS TASK</h1>
    <script>
      //Code-1
      function pairfind(array, argument) {
        //if array element only 1 then return false
        if (array.length <= 1) 
            return false;

        //if 2 array elements and both sum==second argument
        if (array.length === 2)
          return array[0] + array[1] === argument ? true : false;

        //if more than 2 array elements check all elements with other
        const pairIndex = [];
        for (let i = 0; i < array.length; i++) {
          //If i present then skip it
          if (pairIndex.includes(i))
             continue;
          // console.log(pairIndex)

          //If j present then skip it
          for (let j = i + 1; j < array.length; j++) {
            if (pairIndex.includes(j)) 
                continue;
            //  console.log(pairIndex)

            //Sum of Index Match With Second Argument
            if (array[i] + array[j] === argument) {
              pairIndex.push(i, j);
              break;
            }
          }
        }

        //Combine Array Output
        return pairIndex.reduce((result, current) => {
          result = result + current;
          return result;
        }, 0);
      }

      console.log(pairfind([1, 1, 1], 2));
      console.log(pairfind([4, 3, 5, 5, 1, 2, 6, 7], 10));
      console.log(pairfind([7, 9, , 4, 11, 13, 15], 20));

      //Code-2
      const pairFind = (array, argument) => {
        let result = 0;
        let value = 0;
        for (i = 0; i < array.length; i++) {
          for (j = i + 1; j < array.length; j++) {
            if (array[i] + array[j] == argument) {
              value++;
              //console.log([array[i], array[j]]);
              result = result + i;
              result = result + j;
            }
          }
        }
        //console.log(result);
        return result;
      };

      console.log(pairFind([7, 9, 11, 13, 15, 5], 20));
    </script>
  </body>
</html>
